"use strict";
var Registry_1 = require("./Registry");
var getName = function (func) { return func.name; };
exports.getNameIE = function (func) { return func.toString().match(/^(?:function|class)\s+([^\s(]+)/)[1]; };
if (isIE()) {
    getName = exports.getNameIE;
}
function Named(name) {
    if (typeof name === 'string') {
        return function (func) {
            Registry_1.Registry.registerService(name, func);
        };
    }
    else {
        var func = name;
        var fnName = getName(func);
        var key = Registry_1.Registry.resolveName(fnName);
        Registry_1.Registry.registerService(key, func);
    }
}
exports.Named = Named;
function isIE() {
    if (typeof navigator === 'undefined') {
        return false;
    }
    if (navigator.appName === 'Microsoft Internet Explorer') {
        return true;
    }
    if (navigator.appName === 'Netscape') {
        return navigator.appVersion.indexOf('Trident') > -1
            || navigator.appVersion.indexOf('Edge') > -1;
    }
    return false;
}
