export declare class Registry {
    static naming: {
        camelCase(name: string): string;
    };
    static registerService(name: string, type: Function): void;
    static registerValue(name: string, value: any): void;
    static registerFactory(name: string, factory: Function | any[]): void;
    static registerProperty(name: string, type: Function, propertyKey: string): void;
    static registerPostConstruct(type: Function, propertyKey: string): void;
    static getMetadata(name: string): inject.IMetadata;
    static getNames(): string[];
    static getPropertyMetaData(type: Function): Record<string, inject.IPropertyMetadata>;
    static getPostConstructMetaData(type: Function): inject.IPostConstructMetadata;
    private static _injectorFactory;
    static setInjectorFactory(factory: () => inject.IInject): void;
    private static _nameResolver;
    static setNameResolver(resolver: (name: string) => string): void;
    static resolveName(name: string): string;
    static createInjector(): inject.IInject;
}
