"use strict";
var g = typeof global === 'object' ? global :
    typeof window === 'object' ? window :
        typeof self === 'object' ? self : this;
if (!g._jsInjectGlobal) {
    g._jsInjectGlobal = {};
}
var Registry = (function () {
    function Registry() {
    }
    Registry.registerService = function (name, type) {
        var data = { name: name, type: type };
        Reflect.defineMetadata('inject:' + name, data, g._jsInjectGlobal);
    };
    Registry.registerValue = function (name, value) {
        var data = { name: name, value: value };
        Reflect.defineMetadata('inject:' + name, data, g._jsInjectGlobal);
    };
    Registry.registerFactory = function (name, factory) {
        var data = { name: name, factory: factory };
        Reflect.defineMetadata('inject:' + name, data, g._jsInjectGlobal);
    };
    Registry.registerProperty = function (name, type, propertyKey) {
        var $props = Registry.getPropertyMetaData(type) || {};
        $props[propertyKey] = { name: name, type: type, propertyKey: propertyKey };
        Reflect.defineMetadata('inject:properties', $props, type);
    };
    Registry.registerPostConstruct = function (type, propertyKey) {
        var data = { type: type, propertyKey: propertyKey };
        Reflect.defineMetadata('inject:postConstruct', data, type);
    };
    Registry.getMetadata = function (name) {
        return Reflect.getMetadata('inject:' + name, g._jsInjectGlobal);
    };
    Registry.getNames = function () {
        return Reflect.getMetadataKeys(g._jsInjectGlobal)
            .filter(function (name) { return name.substr(0, 7) === 'inject:'; })
            .map(function (name) { return name.substr(7); });
    };
    Registry.getPropertyMetaData = function (type) {
        return Reflect.getMetadata('inject:properties', type);
    };
    Registry.getPostConstructMetaData = function (type) {
        return Reflect.getMetadata('inject:postConstruct', type);
    };
    Registry.setInjectorFactory = function (factory) {
        Registry._injectorFactory = factory;
    };
    Registry.setNameResolver = function (resolver) {
        Registry._nameResolver = resolver;
    };
    Registry.resolveName = function (name) {
        return Registry._nameResolver(name);
    };
    Registry.createInjector = function () {
        return Registry._injectorFactory();
    };
    return Registry;
}());
Registry.naming = {
    camelCase: function (name) {
        return name.substr(0, 1).toLowerCase() + name.substr(1);
    }
};
Registry._nameResolver = Registry.naming.camelCase;
exports.Registry = Registry;
